<?php

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;

class TipoVinculoService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteTipoVinculo($dataset) {
        try {
            $this->entityManager->beginTransaction();
            $vinculoProcesso = $this->entityManager->getRepository(Repositories::FPA_TPVINCPROCESSO)->findBy(array("nrtipovinculom" => $dataset['NRTIPOVINCULOM'], "nrorg" => $dataset['NRORG']));
            if (isset($vinculoProcesso[0])) {
                throw new \Exception(Messages::HCM00000_GER_TIPOVINCULO_ALREADY_EXIST_PROCESSO_ERROR, 10);
            }
            $tipoVinculoh = $this->entityManager->getRepository(Repositories::GPE_TIPOVINCULOH)->findOneBy(array("nrtipovinculom" => $dataset['NRTIPOVINCULOM'], "nrtipovinculoh" => $dataset['NRTIPOVINCULOH']));
            $this->entityManager->remove($tipoVinculoh);
            $this->entityManager->flush();
            $tipoVinculohh = $this->entityManager->getRepository(Repositories::GPE_TIPOVINCULOH)->findOneBy(array("nrtipovinculom" => $dataset['NRTIPOVINCULOM']));
            if(empty($tipoVinculohh)) {
                $tipoVinculom = $this->entityManager->getRepository(Repositories::GPE_TIPOVINCULOM)->findOneBy(array("nrtipovinculom" => $dataset['NRTIPOVINCULOM'],"nrorg" => $dataset['NRORG']));
                $this->entityManager->remove($tipoVinculom);
                $this->entityManager->flush();
            }
            $this->entityManager->commit();
        } catch (\Exception $e) {            
            $this->entityManager->rollback();
            throw $e;
        }
    }
}