<?php

namespace HCM\VAB\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;

class TipolinhavincController extends Crud {

    protected $dataSourceName = 'tipolinhavinc';

    protected $parameterBagColumns = array('P_NRORG', 'P_NRORG_PADRAO');

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters){
        $this->parameterBag = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        parent::__construct($dataSourceManager);
    }

    public function getTipolinhavinc (DTO\Request\Filter $request, DTO\Response $response) {
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData); 
        $response->addDataSet($dataSet);
    }

    public function setTipolinhavinc (DTO\Request\DataSet $request, DTO\Response $response) {
        foreach($request->getDataSet()->getRows() as &$row) {
            if($row['__is_new'] === true){
                $row['DTINCLUSAO'] = date('d/m/Y H:i:s');
                $row['DTULTATU'] = date('d/m/Y H:i:s');
                $row['NRORGINCLUSAO'] = $row['NRORG'];
                $row['NRORGULTATU'] = $row['NRORG'];
                $row['CDOPERINCLUSAO'] = $this->hcmParameters->getCdoperador();
                $row['CDOPERULTATU'] = $this->hcmParameters->getCdoperador();;
            } else if($row['__is_new'] === false){
                $row['DTULTATU'] = date('d/m/Y H:i:s');
                $row['NRORGULTATU'] = $row['NRORG'];
                $row['CDOPERULTATU'] = $this->hcmParameters->getCdoperador();;
            }

            if(array_key_exists('NRTIPOLINHAVINC', $row)){
                if($row['NRTIPOLINHAVINC'] === '' ){
                    $row['NRTIPOLINHAVINC'] = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgPadrao(), 'TIPOLINHAVINC', 1, 12, true);
                }
            } else {
                $row['NRTIPOLINHAVINC'] = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgPadrao(), 'TIPOLINHAVINC', 1, 12, true);
            }
        }

        parent::save($request, $response);
        return true;
    }

    public function delete(DTO\Request\DataSet $request, DTO\Response $response){
        parent::delete($request, $response);
    }

    protected function processConditionValue($condition) {
        return $condition['value'];
    }
    protected function populateParameterBag(FilterCriteria $filterCriteria) {

        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );


        return $newFilterCriteria;
    }
}