<?php

namespace Services\Logic;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;

class ExpedicaoRecurso {
    
    public function executaProcedure($P_NRSEQCONTRATO,$P_NRORG,$P_CDOPERADOR,$P_LISTRECURSO){
        try {

            $procedure = new Procedure("FCT_GERA_PEDIDO");
            $procedure->addParam(
                new Param(
                    'P_NRSEQCONTRATO',
                    Param::PARAM_INPUT,
                    $P_NRSEQCONTRATO,
                    Param::PARAM_TYPE_INT
                )
            );

            $procedure->addParam(
                new Param(
                    'P_NRORG',
                    Param::PARAM_INPUT,
                    $P_NRORG,
                    Param::PARAM_TYPE_INT
                )
            );

            $procedure->addParam(
                new Param(
                    'P_CDOPERADOR',
                    Param::PARAM_INPUT,
                    $P_CDOPERADOR,
                    Param::PARAM_TYPE_STR
                )
            );

            $procedure->addParam(
                new Param(
                    'P_LISTRECURSO',
                    Param::PARAM_INPUT,
                    $P_LISTRECURSO,
                    Param::PARAM_TYPE_STR
                )
            );
            $procedure->addParam(
                new Param(
                    'P_RETORNO',
                    Param::PARAM_OUTPUT,
                    null,
                    Param::PARAM_TYPE_STR,
                    300
                )
            );

            $procedure->addParam(
                new Param(
                    'P_RETORIT',
                    Param::PARAM_OUTPUT,
                    null,
                    Param::PARAM_TYPE_STR,
                    300
                )
            );


            $retornos = $procedure->call();
             

            $retornoPedido = $retornos['P_RETORNO'];
            $retornoItem = $retornos['P_RETORIT'];
             
            $mensErro = null;
            
            if(($retornoPedido === 'OK') && ($retornoItem === 'OK')){
                
                 tk_show_message_by_name('msg_processo_sucesso');
                 $arrBens = \Services\Logic\VerificaParametros::getBensRecurso($P_NRSEQCONTRATO, $P_LISTRECURSO);

                 if(count($arrBens)>0){
                         $mensagem = "Deseja alterar o status de locação do(s) Ativo(s)?";
                           $sim = array(
                              "label" => "Sim",
                              "method" => array("\\Services\\Logic\\VerificaParametros", "updIdbemaloc"),
                              'params_arr' => array($arrBens)
                          );

                          $nao = array(
                              "label" => "Não",
                              'params_arr' => array()
                          );
                          tk_confirm($mensagem, $sim, $nao);
                  }
               

            }else{
               
               if($retornoPedido != 'OK'){
                  $arrayRetorno = explode(';',$retornoPedido);
                  foreach($arrayRetorno as $erro){
                     if($erro == 'CDFILIAL')
                        $mensErro .= "Filial não informada.<br>" ;
                    
                     if($erro == 'CDFILIAL01')
                        $mensErro .= "Filial não cadastrada.<br>" ;

                    if($erro == 'CDTIPOOPER')
                        $mensErro .= "Tipo de operação não parametrizado.<br>" ;

                    
                    if($erro == 'NRPEDIDO')
                        $mensErro .= "Número do pedido não informado.<br>" ;
                    

                    if($erro == 'NRPEDIDO01')
                        $mensErro .= "Número do pedido já cadastrado.<br>" ;

                    if($erro == 'CDMODPGTO')
                        $mensErro .= "Modalidade de pagamento não parametrizada.<br>" ;

                    
                    if($erro == 'CDCLIENTE')
                        $mensErro .= "Cliente não parametrizado.<br>" ;

                    
                    if($erro == 'CDVENDEDOR')
                        $mensErro .= "Vendedor não parametrizado.<br>" ;

                    if($erro == 'CDMODPGTO01')
                        $mensErro .= "Modalidade de pagamento não cadastrada.<br>" ;
                    

                    if($erro == 'CDPRECOBASE')
                        $mensErro .= "Preço base não parametrizado.<br>" ;
                    

                    if($erro == 'IDSITPEDIDO')
                        $mensErro .= "Pedido não possui situação.<br>" ;
                  }    
               }

               if($retornoItem != 'OK'){
                  $arrayRetornoItem = explode(';',$retornoItem);
                  
                  $ultimoIndice = count($arrayRetornoItem) - 1;
                  unset($arrayRetornoItem[$ultimoIndice]);
                  
                  foreach($arrayRetornoItem as $erro){
                       
                          if($erro == 'PRECOVENC'){
                            $mensErro .= "Preço do produto fora da validade.<br>" ;

                          }elseif($erro == 'VRPREUNITPED'){
                            $mensErro .= "Valor do preço unitário do produto deve ser informado.<br>" ;
                          
                          }elseif($erro == 'IDSITITEMPED'){
                            $mensErro .= "Item do pedido não possui situação.<br>" ; 
                          }else{
                             
                              $arrayRecurso = explode('_',$erro);
                              $mensErro .= "Recurso (".$this->getNomeRecurso($arrayRecurso[1]).") Já faz parte de um pedido.<br>";      

                          }
                      
                  }  
                   
              
               }
               tk_abort($mensErro);               
               
            }


        } catch (\Exception $e) {
           tk_warning($e->getMessage());
         }
    }

    public function getNomeRecurso($nrrecurso){
      
      $sql = 'SELECT IDTPRECURSO, CDPRODUTO, CDBEMATIVO, NRPARCNEGOCIO, CDEMPRESA
                FROM FCT_RECURSOSCONTR
               WHERE NRORG = :NRORG
                 AND NRSEQRECUCONT = :NRSEQRECUCONT';

       $params = array("NRORG"=>\Geral\Util\Ambiente::getNrorg(),
                       "NRSEQRECUCONT"=>$nrrecurso,);
                
       $recurso = null;
      
       try{
                        
           $recurso = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        }catch(\Exception $e){
            tk_warning($e->getMessage());
        }

        $recurso = $recurso[0];
       $nome = '';
        
        if($recurso['IDTPRECURSO'] == 'A')
        {
            $nome = $this->getNmBemativo($recurso["CDBEMATIVO"],$recurso["CDEMPRESA"]);
        }
        elseif($recurso['IDTPRECURSO'] == 'F')
        {
            $nome = $this->getNmPessoa($recurso["NRPARCNEGOCIO"]);    
        }
        elseif($recurso['IDTPRECURSO'] == 'P')
        {
            $nome = $this->getNmProduto($recurso["CDPRODUTO"]);    
        }

        return $nome;

    }

    public function getNmBemativo($cdbemativo,$cdempresa){
       $sql = 'SELECT NMBEMATIVO 
                 FROM BEMATIVO 
                WHERE NRORG = :NRORG
                  AND CDBEMATIVO = :CDBEMATIVO
                  AND CDEMPRESA = :CDEMPRESA';
        $params = array("NRORG"=>\Geral\Util\Ambiente::getNrorg(),
                         "CDBEMATIVO"=>$cdbemativo,
                         "CDEMPRESA"=>$cdempresa,);

         try{
                        
           $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        }catch(\Exception $e){
            tk_warning($e->getMessage());
        }
        return $retorno[0]["NMBEMATIVO"];
        
    }

     public function getNmPessoa($nrparcnegocio){
       $sql = 'SELECT NMPRINCIPALPARC 
                 FROM PARCNEGOCIO 
                WHERE NRORG = :NRORG
                  AND NRPARCNEGOCIO = :NRPARCNEGOCIO';
        $params = array("NRORG"=>\Geral\Util\Ambiente::getNrorg(),
                         "NRPARCNEGOCIO"=>$nrparcnegocio,);

         try{
                        
           $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        }catch(\Exception $e){
            tk_warning($e->getMessage());
        }
        return $retorno[0]["NMPRINCIPALPARC"];
        
    }


     public function getNmProduto($cdproduto){
       $sql = 'SELECT NMPRODUTO 
                 FROM PRODUTO 
                WHERE NRORG = :NRORG
                  AND CDPRODUTO = :CDPRODUTO';
        $params = array("NRORG"=>\Geral\Util\Ambiente::getNrorg(),
                         "CDPRODUTO"=>$cdproduto,);

         try{
                        
           $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        }catch(\Exception $e){
            tk_warning($e->getMessage());
        }
        return $retorno[0]["NMPRODUTO"];
        
    }


}


?>
