<?php

class GerSalaLogic{


    private $_GerSalaEntity;
    private $_GepReuniaoEntity;


    public function __construct(){
        $this->_GerSalaEntity    = new GerSalaEntity();
        $this->_GepReuniaoEntity = new GepReuniaoEntity();
    }


    public static function novoCodigoSala(){
        $nrorg = Ambiente::getNrorg();
        $codigo = GerSalaEntity::novoCodigoSala($nrorg);
        return $codigo;
    }


    public function buscaInfoSalas($nrorg, $filial){
        $dados_salas = $this->_GerSalaEntity->consultaSalas($nrorg, $filial);
        $cabecalho = "ATENCAO AS INFORMACOES DAS SALAS<br><br>";
        $mensagem = '';
        foreach ($dados_salas as $info_sala) {
            $mensagem .= "Dados Gerais<br>";
            $mensagem .= "Nome: ".$info_sala->getNmsala()."<br>";
            $mensagem .= "Capacidade Maxima: ".$info_sala->getQtmaximapessoas()." pessoas<br>";
            $mensagem .= "Qtd Reuniao Concomitantes: ".$info_sala->getQtreuniao()."<br><br>";
        }

        if (empty($mensagem) === false) {
            $mensagem = $cabecalho.$mensagem;
        } else {
            $mensagem = "Nao ha informacoes sobre as salas.";
        }

        return $mensagem;
    }


    /**    ok
     * Anexa arquivos no diretorio parametrizado.
     *
     * @param string $dir_origem  Diretorio de origem.
     * @param string $dir_destino Diretorio de destino.
     *
     * @return boolean
     */
    public function incluiAnexosEncaminhamento($dir_origem, $dir_destino) {
        try {
            $dirObj_or = new DirectoryIterator($dir_origem);
            foreach($dirObj_or as $file_or){
                if (is_dir($file_or) === false) {
                    $nome_arquivo = $file_or->getFilename();
                    $nome_arquivo_novo = strtr(utf8_decode($nome_arquivo), utf8_decode("áàãâéêíóôõúüçÁÀÃÂÉÊÍÓÔÕÚÜÇ "), "aaaaeeiooouucAAAAEEIOOOUUC_");
                    $nome_arquivo_novo = utf8_encode($nome_arquivo_novo);

                    $FILE = new TkFile($dir_destino, false, TkFile::MODE_DIR);
                    rename($dir_origem.DIRECTORY_SEPARATOR.$nome_arquivo, $dir_destino.DIRECTORY_SEPARATOR.$nome_arquivo_novo);
                    return true;
                }
            }
        } catch (Exception $e) {
            tk_warning($e->getMessage());
            return false;
        }
    }

}