CREATE OR REPLACE FUNCTION SPED_BLOCO9_FOS(
   P_CONTREGC  IN NUMBER,
   P_CONTREGD  IN NUMBER,
   P_CONTREGE  IN NUMBER,
   P_CONTREGH  IN NUMBER,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE) RETURN NUMBER
AS
   V_MOVIMENT     NUMBER;
   V_TOTREG9      NUMBER;
   V_CONTREG9     NUMBER;
   V_TOTREG       NUMBER;
   V_CONTREGA     NUMBER;
   V_0200         VARCHAR2(400);
BEGIN
  /* REGISTRO 0190 */
   V_CONTREGA := 0;
   FOR C_0190 IN (SELECT '|0190'        || '|' ||
                         U.SGUNIDADE    || '|' ||
                         U.DSUNIDADE    || '|' AS UNID
                    FROM TMP_REGDADOSSPED R, UNIDMEDIDA U
                   WHERE R.CDREGISTRO = '0190'
                     AND R.CDCHAVEREG = U.SGUNIDADE) LOOP

      V_CONTREGA := NVL(V_CONTREGA,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('08'||LPAD(RTRIM(V_CONTREGA), 8, '0'), C_0190.UNID, P_NRSEQARQMAG);
   END LOOP;

   /* REGISTRO 0200 */
   FOR C_0200 IN (SELECT CDCHAVEREG
                    FROM TMP_REGDADOSSPED
                   WHERE CDREGISTRO = '0200') LOOP

      SELECT MAX('|0200'     || '|' ||
             P.CDARVPROD     || '|' ||
             P.NMPRODUTO     || '|' ||
             ''              || '|' ||
             ''              || '|' || /* COD_ANT_ITEM */
             P.SGUNIDADE     || '|' ||
             R.CDTPITEMPROD  || '|' || /* TIPO ITEM */
             ''              || '|' ||
             ''              || '|' ||
             R.CDGENPROD     || '|' ||
             ''              || '|' ||
             ''              || '|'  ) AS C_0200
        INTO V_0200
        FROM RELACPRODITGEN R, PRODUTO P
       WHERE R.CDPRODUTO = C_0200.CDCHAVEREG
         AND R.CDPRODUTO = P.CDPRODUTO;

      IF V_0200 IS NOT NULL THEN
         V_CONTREGA := NVL(V_CONTREGA,0) + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('08'||LPAD(RTRIM(V_CONTREGA), 8, '0'), V_0200, P_NRSEQARQMAG);
      END IF;
   END LOOP;

   IF V_CONTREGA > 0 THEN
      /* ENCERRAMENTO DO BLOCO 0 */
      V_CONTREGA := NVL(V_CONTREGA,0) + 4;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('10'||LPAD(RTRIM(V_CONTREGA), 8, '0'), '|0990'|| '|' ||V_CONTREGA|| '|' , P_NRSEQARQMAG);
      
   END IF;

   COMMIT;

   /* encerramento do bloco 0 */
   FOR REG_C IN (SELECT SUBSTR(DSREGARQMAG,2,4) AS BLOCO, COUNT(*) AS QTDE
                   FROM ARQMAGNETICO
                  WHERE SUBSTR(DSREGARQMAG,2,1) = '0'
                    AND NRSEQARQMAG = P_NRSEQARQMAG
                  GROUP BY SUBSTR(DSREGARQMAG,2,4)
                  ORDER BY SUBSTR(DSREGARQMAG,2,4) ) LOOP

      V_CONTREG9 := NVL(V_CONTREG9,0) + 1;

      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||REG_C.BLOCO||'|' ||REG_C.QTDE|| '|', P_NRSEQARQMAG);
   END LOOP;

   /* encerramento do bloco C */
   FOR REG_C IN (SELECT SUBSTR(DSREGARQMAG,2,4) AS BLOCO, COUNT(*) AS QTDE
                   FROM ARQMAGNETICO
                  WHERE SUBSTR(DSREGARQMAG,2,1) = 'C'
                    AND NRSEQARQMAG = P_NRSEQARQMAG
                  GROUP BY SUBSTR(DSREGARQMAG,2,4)
                  ORDER BY SUBSTR(DSREGARQMAG,2,4) ) LOOP

      V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||REG_C.BLOCO||'|' ||REG_C.QTDE|| '|', P_NRSEQARQMAG);

   END LOOP;

   /* encerramento do bloco D */
   FOR REG_C IN (SELECT SUBSTR(DSREGARQMAG,2,4) AS BLOCO, COUNT(*) AS QTDE
                   FROM ARQMAGNETICO
                  WHERE SUBSTR(DSREGARQMAG,2,1) = 'D'
                    AND NRSEQARQMAG = P_NRSEQARQMAG
                  GROUP BY SUBSTR(DSREGARQMAG,2,4)
                  ORDER BY SUBSTR(DSREGARQMAG,2,4) ) LOOP

      V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||REG_C.BLOCO||'|' ||REG_C.QTDE|| '|', P_NRSEQARQMAG);
   END LOOP;

   /* encerramento do bloco E */
   FOR REG_C IN (SELECT SUBSTR(DSREGARQMAG,2,4) AS BLOCO, COUNT(*) AS QTDE
                   FROM ARQMAGNETICO
                  WHERE SUBSTR(DSREGARQMAG,2,1) = 'E'
                    AND NRSEQARQMAG = P_NRSEQARQMAG
                  GROUP BY SUBSTR(DSREGARQMAG,2,4)
                  ORDER BY SUBSTR(DSREGARQMAG,2,4) ) LOOP

      V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||REG_C.BLOCO||'|' ||REG_C.QTDE|| '|', P_NRSEQARQMAG);
   END LOOP;

   /* encerramento do bloco H */
   FOR REG_C IN (SELECT SUBSTR(DSREGARQMAG,2,4) AS BLOCO, COUNT(*) AS QTDE
                   FROM ARQMAGNETICO
                  WHERE SUBSTR(DSREGARQMAG,2,1) = 'H'
                    AND NRSEQARQMAG = P_NRSEQARQMAG
                  GROUP BY SUBSTR(DSREGARQMAG,2,4)
                  ORDER BY SUBSTR(DSREGARQMAG,2,4) ) LOOP

      V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||REG_C.BLOCO||'|' ||REG_C.QTDE|| '|', P_NRSEQARQMAG);

   END LOOP;

   V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||'1001'|| '|' ||'1'|| '|', P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 8990 */
   V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||'1990'|| '|' ||'1'|| '|', P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 9001 */
   V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||'9001'|| '|' ||'1'|| '|', P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 9900 */
   V_TOTREG := 0;
   V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
   SELECT COUNT(*)
     INTO V_TOTREG
     FROM ARQMAGNETICO
    WHERE SUBSTR(DSREGARQMAG,2,4) = '9900'
      AND NRSEQARQMAG = P_NRSEQARQMAG;
   IF V_TOTREG IS NOT NULL THEN
      V_TOTREG := NVL(V_TOTREG,0) + 3;  /*CONTA OS REGISTROS RESTANTES (9900, 9990, 9999) */
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||'9900'|| '|' ||V_TOTREG|| '|', P_NRSEQARQMAG);
   END IF;

   /* TOTALIZAO DO BLOCO 9990 */
   V_CONTREG9 := NVL(V_CONTREG9,0) + 2;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||'9990'|| '|' ||'1'|| '|', P_NRSEQARQMAG);

   /* TOTALIZAO DO BLOCO 9999 */
   V_CONTREG9 := NVL(V_CONTREG9,0); -- + 3;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('90'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9900'|| '|' ||'9999'|| '|' ||'1'|| '|', P_NRSEQARQMAG);

   /* ABERTURA DO BLOCO 9 */
   IF V_CONTREG9 <> 0 THEN
      V_MOVIMENT := 0;
   ELSE
      V_MOVIMENT := 1;
   END IF;

   V_CONTREG9 := NVL(V_CONTREG9,0) + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('89'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9001'|| '|' ||V_MOVIMENT|| '|' , P_NRSEQARQMAG);

   /* ENCERRAMENTO DO BLOCO 9 */
   V_CONTREG9 := NVL(V_CONTREG9,0) + 2;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('95'||LPAD(RTRIM(V_CONTREG9), 8, '0'), '|9990'|| '|' ||V_CONTREG9|| '|', P_NRSEQARQMAG);
   RETURN(V_CONTREG9);

END;
/