function ContainerDecoratorDeveloper(ZHPromise){
    var mappedFormats = {
        yy: 'YYYY',
        hh: 'hh',
        dd: 'DD',
        ii: 'mm',
        i: 'm',
        mm: 'MM',
        ss: 'ss',
        y: 'YYY',
        m: 'M',
        d: 'D',
        h: 'h',
        s: 's',
        H: 'H',
        D: 'ddd',
        M: 'MMM',
        DD: 'dddd',
        HH: 'HH',
        MM: 'MMMMM',
        a: 'a',
        A: 'A'
    };

    function translateZhDateToMobiscrollDate(input){
        Object.keys(mappedFormats).forEach(function(mobiFormat){
            input = input.replace(mappedFormats[mobiFormat], mobiFormat);
        });
        return input;
    }

    function getTemplateSimpleName(template){
        return template && template.split("/").pop();
    }

    function defineDatetimeProperty(field, propertyName){
        var datetimePropertyName = 'datetime-'.$propertyName;
        if(!field[datetimePropertyName] && field[propertyName]){
            field[datetimePropertyName] = translateZhDateToMobiscrollDate(field[propertyName]);
        }
    }
    
    function defineCalendarProperty(field, propertyName){
        if(!field[propertyName]){
            field[propertyName] = "DD/MM/YYYY";
        }
        /*
        if(field.filterProperties && field.filterProperties.template == "zh-interval-component#field/interval.html"){
            field.filterProperties.isVisible = false;
        }*/
    }
    
    function defineIntervalPropertyCaseCustom(field){
        field.template = "field/calendar.html";
        field.dateFormat = "DD/MM/YYYY";
        
        if(field.filterProperties == null || field.filterProperties == "")
            field.filterProperties = {template: "zh-interval-component#field/interval.html"};
        else
            field.filterProperties.template = "zh-interval-component#field/interval.html";
    }
    
    function defineCheckBoxProperty(field) {
        if(Util.isUndefined(field.valueToTrue)) {
            field.valueToTrue = "S";
            field.valueToFalse = "N";
        }
        
    }
    
    function defineAutoCompleteProperty(field, widget){
        var widgetName = ['envioCadastros', 'fpaItecalcfolha'];
        var events = []; 
        
        //alguns campos já tem um fieldBeforeSelectOpen; alguns dao reloads em outras funções
        
        if(widgetName.find(function(name){ return name == widget.name;})){
            events.push({
                          name: "FieldOnClick",
                          code: "ABUtilController.LoadDataAutoComplete(args.owner.field, false)"
                      });
        }else {
            events.push({
                            name: "FieldOnClick",
                            code: "ABUtilController.LoadDataAutoComplete(args.owner.field, true);"
                        },
                        {
                            name: 'FieldAfterSelectOpen',
                            code: 'ABUtilController.reactivateRefreshButton();'
                        },
                        {
                            name: 'WidgetPopUpOnCancel',
                            code: 'ABUtilController.deactivateRefreshButton();'
                        },
                        {
                            name: 'WidgetBeforeSelectRow',
                            code: 'ABUtilController.deactivateRefreshButton();'
                        });
        }
        
        if(!field.events || field.events.length === 0){
            field.events = events;
        }else{
            if(events.length >= 1){
                var eventsConcat = angular.copy(events);
                field.events.forEach(function(event){
                    if(event.name == 'FieldBeforeSelectOpen'){
                        event.code += ';' + events[0].code;
                        delete eventsConcat[0];
                    }else if(event.name == 'FieldAfterSelectOpen'){
                        event.code += ';' + events[1].code;
                        delete eventsConcat[1];
                    }else if (event.name == 'WidgetPopUpOnCancel'){
                        event.code += ';' + events[2].code;
                        delete eventsConcat[2];
                    }else if (event.name == 'WidgetBeforeSelectRow'){
                        event.code += ';' + events[3].code;
                        delete eventsConcat[3];
                    }
                });
                if(eventsConcat.length > 0){
                    eventsConcat.forEach(function(eventConcat){
                        field.events.push(eventConcat);
                    });
                }
            }else{
                var fieldFilter = field.events.find(function(ev){ return ev.name == 'FieldBeforeSelectOpen';}); 
                if(fieldFilter){
                    fieldFilter.code += ';' + events[0].code;
                } else {
                    field.events.push(event);
                }
            }
            // field.events.find(function(ev){ return ev.name == 'FieldBeforeSelectOpen';}) ? field.events.find(function(ev){ return ev.name == 'FieldBeforeSelectOpen';}).code += ';' + event.code : field.events.push(event);
        }
        
        if(!field.showSelectAs){
            field.showSelectAs = "grid";
        }
        
        field.defaultSearchField = "__ALL_MAP";
        field.itemsPerPage = 9999;
        field.hasPagination = false;
        field.searchWithPagination = false;
    }
    
    function defineMultipleProperty(field){
        
        field.defaultSearchField = "__ALL_MAP";
        field.itemsPerPage = 9999;
        field.hasPagination = false;
        field.searchWithPagination = false;
    }

    function correctDatetimeFields(widget){
        if(widget.fields){
            widget.fields.forEach(function(field){
                if(getTemplateSimpleName(field.template) == 'datetime.html'){
                    var w = widget;
                    defineDatetimeProperty(field, 'dateFormat');
                    defineDatetimeProperty(field, 'timeFormat');
                }
                if(getTemplateSimpleName(field.template) == 'calendar.html'){
                    defineCalendarProperty(field, 'dateFormat');
                }
                if(getTemplateSimpleName(field.template) == 'select-autocomplete.html'){
                    defineAutoCompleteProperty(field, widget);
                }
                if(getTemplateSimpleName(field.template) == 'select-multiple.html'){
                    defineMultipleProperty(field);
                }
                if(getTemplateSimpleName(field.template) == 'interval.html'){
                    defineIntervalPropertyCaseCustom(field);
                }
                if(getTemplateSimpleName(field.template) == 'checkbox.html'){
                    defineCheckBoxProperty(field);
                }
            }.bind(this));
        }
    }
    

    this.apply = function(containerName, container){
        var _eachWidget = function(widget, fn){
            fn(widget);
            widget.itemsPerPage = 9999;
            widget.hasPagination = false;
            widget.searchWithPagination = false;
            
            if(widget.widgets){
                widget.widgets.forEach(function(widget){
                    _eachWidget(widget, fn);
                });
            }
        };

        if(container.widgets){
            container.widgets.forEach(function(widget){
                _eachWidget(widget, correctDatetimeFields);
            });
        }

        return ZHPromise.when(container);
    };
}

ZeedhiApp.run(function(ContainerDecoratorProvider, ZHPromise){
    ContainerDecoratorProvider.registerProvider(new ContainerDecoratorDeveloper(ZHPromise));
});